// MenuList.h

#pragma once

struct MenuElement {
	MenuHandle		menu;
	short			leftEdge;
};

typedef struct MenuElement MenuElement;

struct MenusList {
	short			itemsOffset;			// offset to last menu item.
	short			rightEdge;				// right edge of the menu.
	short			resId;					// resource id of MBDF.
	MenuElement		elements[];				// array of menu items.
};

typedef struct MenusList MenusList, **MenusListHandle;

MenusListHandle theMenus : 0xa1c;
MenusListHandle theSystemMenus : 0x286;		// System 7 menu list.
