/* @(#) Savvy.h 6/19/92
	{Sources}Hack:Savvy.h

	No rights reserved
	
	Product:		Joels MacHack 92 entry
	File:			Savvy.c
	Author:			Joel West, Palomar Software
	Date:			Wed, Jun 17, 1992
*/

#define qUseIconSuite						// ref TN #306

#define kICNN_DoSavvy	1000
#define kICNN_Unsavvy	1001

#define kICNN_24bitclean	150
#define kICNN_32bitclean	151
#define kICNN_NotAtAllSavvy	152

#define kSTR_Finder			128
#define kSTR_GetInfoSubstr	129

#ifndef REZ
#include <Types.h>
#include <Windows.h>
typedef short Integer;

enum	{ noSizeRsrc = -1, notApp = -2 };	// psuedo-error

#define gCurApName	((StringPtr)0x910)


typedef struct {
	int unused1: 1;
	unsigned int acceptSuspendResumeEvents:1;	// else ignoreSuspendResumeEvents
	int unused2: 1;
	unsigned int canBackground:1;
	unsigned int doesActivateOnFGSwitch:1;		// else needsActivateOnFGSwitch
	unsigned int onlyBackground:1;				// else backgroundAndForeground
	unsigned int getFrontClicks:1;
	unsigned int acceptAppDiedEvents:1;			// false except for debuggers

	unsigned int is32BitCompatible:1;
		/* System 7.0 stuff */
	unsigned int isHighLevelEventAware:1;
	unsigned int localAndRemoteHLEvents:1;		// else onlyLocalHLEvents
	unsigned int isStationeryAware:1;
	unsigned int useTextEditServices:1;
	int unused3: 3;

	long prefMemory;
	long minMemory;
} TSizeStruct;

typedef pascal Handle (*GetResourceProcPtr)(OSType, short); 
typedef pascal WindowPtr (*NewWindowProcPtr)(void *,const Rect *,
	ConstStr255Param,
    Boolean ,short ,WindowPtr ,Boolean ,long );
typedef pascal void (*ShowWindowProcPtr)(WindowPtr theWindow); 

typedef struct {
	GetResourceProcPtr oldGet1Resource;
	NewWindowProcPtr oldNewCWindow;
	NewWindowProcPtr oldNewWindow;
	ShowWindowProcPtr oldShowWindow;
	TSizeStruct lastSizeRsrc;
	Boolean	lastSizeValid;
	Boolean possibleGetInfoWindow;
#ifdef qUseIconSuite
	Handle	h24bitIconSuite;
	Handle  h32bitIconSuite;
	Handle	hUnsavvyIconSuite;
#else
	Handle	h24bitIcon;
	Handle  h32bitIcon;
	Handle	hUnsavvyIcon;
#endif qUseIconSuite
	Handle	hFinderNameString;
	Handle	hGetInfoSubstrString;
} *TGlobalsPtr;

	/* ShowInit.a */
pascal void ShowINIT(Integer iconID, Integer moveX);
enum { kShowInitStdOffset=-1 };

	/* Savvy.a */
void StashOldTrapAddr(long OldGet1Resource, long OldNewCWindow, long OldShowWindow);
pascal Handle Get1ResourceWrapper(OSType thetype, Integer theid);
TGlobalsPtr GetGlobals(void);

	/* SavvyInit.c */
pascal WindowPtr NewWindowTailPatch(void *wStorage,const Rect *boundsRect,ConstStr255Param title,
    Boolean visible,short procID,WindowPtr behind,Boolean goAwayFlag,long refCon);
pascal WindowPtr NewCWindowTailPatch(void *wStorage,const Rect *boundsRect,ConstStr255Param title,
    Boolean visible,short procID,WindowPtr behind,Boolean goAwayFlag,long refCon);
pascal void ShowWindowTailPatch(WindowPtr theWindow);


#endif REZ
