#   File:       Makefile
#   Target:     Savvy
#   Sources:    SavvyInit.c Savvy.a
#   Created:    Wednesday, June 17, 1992 6:55:58 PM

LOpts = -rn -sg main
COpts = -b2 -r

MAKEFILE = #	Savvy.Make

TOOLOBJS = IsSavvyTool.c.o

INITOBJS = SavvyInit.c.o Savvy.a.o ShowINIT.a.o
# 		the INIT code MUST go first

# Make the real INIT

Savvy  {MAKEFILE} {INITOBJS} SavvyInit.r		#	IsSavvy
	Delete -i {Targ}
	Link -d -c 'JWWe' -t 'INIT' 
		-m InitEntry -rt INIT=0  -ra =resSysHeap,resLocked 
		{LOpts} {INITOBJS} 
		"{Libraries}"Interface.o 
		"{CLibraries}"StdClib.o 
		-o {Targ}
	SetFile -a B {Targ}
	Rez -o {Targ} -a SavvyInit.r
	Duplicate -y {Targ} "{SystemFolder}Extensions:"

Savvy.c.o  {MAKEFILE} Savvy.c Savvy.h
	 C {COpts} Savvy.c
SavvyInit.c.o  {MAKEFILE} SavvyInit.c Savvy.h
	 C {COpts} SavvyInit.c


# Make the MPW tool for testing the algorithm

IsSavvy  {MAKEFILE} {TOOLOBJS}
	Link -d -c 'MPS ' -t MPST 
		{LOpts} {TOOLOBJS} 
		"{CLibraries}"StdClib.o 
		"{Libraries}"Stubs.o 
		"{Libraries}"Runtime.o 
		"{Libraries}"Interface.o 
		"{Libraries}"ToolLibs.o 
		-o IsSavvy

IsSavvyTool.c.o  {MAKEFILE} IsSavvyTool.c Savvy.h
	 C {COpts} IsSavvyTool.c
